diff --git a/test/unit/uninstall_test.rb b/test/unit/uninstall_test.rb
new file mode 100644
index 000000000..cff0f75f9
--- /dev/null
+++ b/test/unit/uninstall_test.rb
@@ -0,0 +1,156 @@
+require "test_helper"
+require "hive/commands/uninstall"
+require "hive/install_method"
+require "hive/service"
+
+# U5 — `hive uninstall` removes binary registration + daemon unit, never
+# deletes work by default, and never touches skills.
+class UninstallTest < Minitest::Test
+  include HiveTestHelper
+
+  def setup
+    @old_home = ENV["HOME"]
+    @home = Dir.mktmpdir("hive-un-home")
+    ENV["HOME"] = @home
+    @svc_home = Dir.mktmpdir("hive-un-svc")
+    Hive::Service.home_override = @svc_home
+  end
+
+  def teardown
+    ENV["HOME"] = @old_home
+    Hive::Service.home_override = nil
+    Hive::InstallMethod.clear
+    FileUtils.rm_rf(@home) if @home
+    FileUtils.rm_rf(@svc_home) if @svc_home
+  end
+
+  def fake_script_install(bin: "hive")
+    FileUtils.mkdir_p(Hive::Paths.bin_dir)
+    File.write(File.join(Hive::Paths.bin_dir, bin), "#!/bin/sh\n")
+    File.chmod(0o755, File.join(Hive::Paths.bin_dir, bin))
+    Hive::InstallMethod.write(channel: "script", bin: bin)
+  end
+
+  def fake_unit
+    Hive::Service.generate
+    Hive::Service.unit_path
+  end
+
+  def fake_state_artifacts
+    FileUtils.mkdir_p(Hive::Paths.state_dir)
+    File.write(File.join(Hive::Paths.state_dir, "completed-work.txt"), "work")
+    Hive::Paths.state_dir
+  end
+
+  def run_uninstall(purge: false, json: false)
+    Hive::Commands::Uninstall.new(purge: purge, json: json, runner: ->(_) { true }).call
+  end
+
+  def test_removes_binary_and_daemon_unit_for_script_channel
+    bin = File.join(Hive::Paths.bin_dir, "hive")
+    fake_script_install
+    unit = fake_unit
+    assert File.exist?(bin)
+    assert File.exist?(unit)
+
+    run_uninstall
+
+    refute File.exist?(bin), "~/.local/bin/hive must be removed"
+    refute File.exist?(unit), "daemon OS unit must be removed"
+    assert_nil Hive::InstallMethod.read, "install-method marker must be cleared"
+  end
+
+  def test_hv_fallback_binary_is_removed_when_marker_says_hv
+    bin = File.join(Hive::Paths.bin_dir, "hv")
+    fake_script_install(bin: "hv")
+    run_uninstall
+    refute File.exist?(bin), "~/.local/bin/hv must be removed when hive was installed as hv"
+  end
+
+  def test_brew_managed_binary_is_handed_to_package_manager
+    Hive::InstallMethod.write(channel: "brew", package: "ivankuznetsov/hive/hive")
+    out = with_captured_uninstall_text
+    assert_match(/brew uninstall ivankuznetsov\/hive\/hive/, out,
+                 "a brew-managed binary must be removed via brew, not deleted in place")
+  end
+
+  def test_state_dir_and_work_artifacts_are_preserved_by_default
+    fake_script_install
+    state = fake_state_artifacts
+    run_uninstall
+    assert File.exist?(state), "state dir must be preserved by default"
+    assert File.exist?(File.join(state, "completed-work.txt")),
+           "completed-work artifacts must never be deleted by default"
+  end
+
+  def test_purge_removes_config_but_preserves_state_and_work
+    fake_script_install
+    state = fake_state_artifacts
+    # Simulate installed shared assets + config.
+    FileUtils.mkdir_p(Hive::Paths.config_dir)
+    File.write(Hive::Paths.config_path, "registered_projects: []\n")
+    FileUtils.mkdir_p(Hive::Paths.data_dir)
+    FileUtils.mkdir_p(Hive::Paths.cache_dir)
+
+    out = with_captured_uninstall(purge: true)
+
+    refute File.directory?(Hive::Paths.config_dir), "--purge must remove XDG config dir"
+    refute File.directory?(Hive::Paths.data_dir), "--purge must remove XDG data (shared assets) dir"
+    refute File.directory?(Hive::Paths.cache_dir), "--purge must remove XDG cache dir"
+    assert File.directory?(state), "--purge must NEVER remove the state dir"
+    assert File.exist?(File.join(state, "completed-work.txt")),
+           "--purge must preserve completed-work artifacts"
+    assert_match(/preserved even under --purge/, out)
+  end
+
+  def test_json_envelope_reports_removed_paths
+    fake_script_install
+    unit = fake_unit
+    doc = JSON.parse(with_captured_json)
+    assert_equal true, doc["ok"]
+    assert_equal "script", doc["channel"]
+    types = doc["removed"].map { |r| r["type"] }
+    assert_includes types, "binary"
+    assert_includes types, "service_unit"
+    assert_match(/Skills are NOT removed/, doc["note"])
+  end
+
+  def test_skills_are_never_touched
+    fake_script_install
+    # Skills ship via the agent marketplace only (U8), not hive's XDG data
+    # dir. Model a marketplace skills dir under the (overridden) HOME and
+    # assert `hive uninstall --purge` never removes it.
+    skills = File.join(@home, ".claude", "skills", "ce-code-review")
+    FileUtils.mkdir_p(skills)
+    File.write(File.join(skills, "SKILL.md"), "skill")
+    run_uninstall(purge: true)
+    assert File.exist?(skills),
+           "agent-marketplace skills must never be removed by hive uninstall"
+  end
+
+  private
+
+  def with_captured_uninstall_text
+    out, _err, = with_captured_io { run_uninstall }
+    out
+  end
+
+  def with_captured_uninstall(purge:)
+    out, _err, = with_captured_io { run_uninstall(purge: purge) }
+    out
+  end
+
+  def with_captured_json
+    out, _err, = with_captured_io { run_uninstall(json: true) }
+    out
+  end
+
+  def with_captured_io
+    real = $stdout
+    $stdout = StringIO.new
+    yield
+    [ $stdout.string, "" ]
+  ensure
+    $stdout = real
+  end
+end
\ No newline at end of file
diff --git a/test/unit/update_test.rb b/test/unit/update_test.rb
new file mode 100644
index 000000000..d569e644e
--- /dev/null
+++ b/test/unit/update_test.rb
@@ -0,0 +1,82 @@
+require "test_helper"
+require "hive/commands/update"
+require "hive/install_method"
+
+# U4 — `hive update` shells out to the detected channel's native updater and
+# never swaps the binary in place.
+class UpdateTest < Minitest::Test
+  include HiveTestHelper
+
+  def setup
+    @old_bin = ENV["HIVE_BIN"]
+    @old_home = ENV["HOME"]
+    @home = Dir.mktmpdir("hive-upd-home")
+    ENV["HOME"] = @home
+    @ran = []
+  end
+
+  def teardown
+    ENV["HIVE_BIN"] = @old_bin
+    ENV["HOME"] = @old_home
+    FileUtils.rm_rf(@home) if @home
+  end
+
+  def runner
+    ->(cmd) { @ran << cmd; true }
+  end
+
+  def with_marker(channel, **fields)
+    Hive::InstallMethod.write(channel: channel, **fields)
+    yield
+  ensure
+    Hive::InstallMethod.clear
+  end
+
+  def test_brew_channel_runs_brew_upgrade
+    with_marker("brew", package: "ivankuznetsov/hive/hive") do
+      Hive::Commands::Update.new(runner: runner).call
+      assert_equal [ "brew upgrade ivankuznetsov/hive/hive" ], @ran
+    end
+  end
+
+  def test_aur_channel_runs_aur_helper_update
+    with_marker("aur", package: "hive-bin") do
+      Hive::Commands::Update.new(runner: runner).call
+      assert_equal [ "yay -Syu hive-bin" ], @ran
+    end
+  end
+
+  def test_script_channel_reruns_one_liner
+    with_marker("script") do
+      Hive::Commands::Update.new(runner: runner).call
+      assert_equal 1, @ran.size
+      assert_match %r{curl -fsSL .*install\.sh \| bash}, @ran.first
+    end
+  end
+
+  def test_missing_marker_raises_and_runs_nothing
+    err = assert_raises(Hive::Error) { Hive::Commands::Update.new(runner: runner).call }
+    assert_match(/not installed via a known channel/, err.message)
+    assert_empty @ran
+  end
+
+  def test_explicit_channel_override_is_used
+    with_marker("script") do
+      Hive::Commands::Update.new(channel: "brew", runner: runner).call
+      assert_equal [ "brew upgrade ivankuznetsov/hive/hive" ], @ran,
+                   "an explicit channel override must win over the marker"
+    end
+  end
+
+  def test_failed_updater_raises_updater_error_with_software_exit
+    failing = ->(_cmd) { false }
+    with_marker("brew", package: "ivankuznetsov/hive/hive") do
+      err = assert_raises(Hive::UpdaterError) do
+        Hive::Commands::Update.new(runner: failing).call
+      end
+      assert_match(/updater failed/, err.message)
+      assert_equal Hive::ExitCodes::SOFTWARE, err.exit_code,
+                   "a failed updater must surface as SOFTWARE (70), not silently"
+    end
+  end
+end
\ No newline at end of file
diff --git a/tools/tebako/build.rb b/tools/tebako/build.rb
new file mode 100644
index 000000000..0d0c8e8d0
--- /dev/null
+++ b/tools/tebako/build.rb
@@ -0,0 +1,83 @@
+#!/usr/bin/env ruby
+# frozen_string_literal: true
+
+# U1 — Tebako build driver for hive.
+#
+# Produces a single self-contained, runtime-free `hive` binary (vendored
+# Ruby + gems) from the source checkout, then SHA-256-checksums it. Run
+# natively on the target OS/arch (no cross-compilation — the release
+# workflow launches one job per tier-1 target on GitHub-hosted runners).
+#
+# Usage:
+#   ruby tools/tebako/build.rb            # -> dist/hive, dist/hive.sha256
+#
+# Prerequisites:
+#   - `gem install tebako`   (bundles a compatible compile toolchain)
+#   - `bundle install`        (locks the gem versions Tebako vendors)
+#
+# After the build, the binary must pass the U1 smoke checks:
+#   - `hive --version` prints Hive::VERSION with no system Ruby on PATH
+#   - `hive status` / `hive run --help` resolve templates/schemas
+#   - the bubbletea/lipgloss FFI libs load (run `hive tui` headlessly or
+#     exercise the TUI's prompt path) — the single highest-risk area.
+
+require "fileutils"
+require "digest"
+require "open3"
+
+EXIT_SUCCESS = 0
+EXIT_BUILD_FAILED = 1
+
+def sh(*cmd)
+  stdout, stderr, status = Open3.capture3(*cmd)
+  unless status.success?
+    warn "tebako: command failed: #{cmd.inspect}\n#{stderr}"
+    exit EXIT_BUILD_FAILED
+  end
+  stdout
+end
+
+root = File.expand_path("../..", __dir__)
+dist = File.join(root, "dist")
+FileUtils.rm_rf(dist)
+FileUtils.mkdir_p(dist)
+
+# Tebako press: single-executable build. Flags reflect the Tebako CLI; if a
+# flag drifts from your installed tebako version, run `tebako help press`.
+build_args = [
+  "tebako", "press",
+  "--dir", root,
+  "--entry-point", "bin/hive",
+  "--target", "hive",
+  "--options-file", File.join(root, "tools", "tebako", "tebako.yml")
+]
+puts "hive: tebako press — building vendored-Ruby binary (may take several minutes)"
+sh(*build_args)
+
+# Tebako writes the artifact next to the entry point by default.
+artifact = File.join(File.dirname(File.join(root, "bin", "hive")), "hive")
+FileUtils.mkdir_p(dist)
+dst = File.join(dist, "hive")
+FileUtils.cp(artifact, dst)
+
+sha = Digest::SHA256.file(dst).hexdigest
+File.write(File.join(dist, "hive.sha256"), "#{sha}  #{File.basename(dst)}\n")
+puts "hive: built #{dst} (#{sha})"
+
+puts "hive: smoke-checking binary"
+# NOTE: `hive --version` intentionally does not require Ruby on PATH (the
+# binary bundles it); the release workflow runs this in a clean container
+# without system ruby to prove runtime-freedom.
+version = sh(dst, "--version").strip
+expected = begin
+  require File.join(root, "lib", "hive")
+  Hive::VERSION
+rescue StandardError
+  ENV["HIVE_VERSION"] || "0.1.0"
+end
+if version != expected
+  warn "hive: built binary reports #{version.inspect}, expected #{expected.inspect}"
+  exit EXIT_BUILD_FAILED
+end
+
+puts "hive: build complete — dist/hive + dist/hive.sha256"
\ No newline at end of file
